; =============== S U B	R O U T	I N E =======================================


RESET:					
		tst.l	($A10008).l
		bne.s	loc_20E
		tst.w	($A1000C).l

loc_20E:				
		bne.s	loc_28C
		lea	std_init_table(pc),a5
		movem.w	(a5)+,d5-d7
		movem.l	(a5)+,a0-a4
		move.b	-$10FF(a1),d0
		andi.b	#$F,d0
		beq.s	loc_22E
		move.l	#'SEGA',$2F00(a1)

loc_22E:				
		move.w	(a4),d0
		moveq	#0,d0
		movea.l	d0,a6
		move.l	a6,usp
		moveq	#$17,d1

loc_238:				
		move.b	(a5)+,d5
		move.w	d5,(a4)
		add.w	d7,d5
		dbf	d1,loc_238
		move.l	(a5)+,(a4)
		move.w	d0,(a3)
		move.w	d7,(a1)
		move.w	d7,(a2)

loc_24A:				
		btst	d0,(a1)
		bne.s	loc_24A
		moveq	#$25,d2

loc_250:				
		move.b	(a5)+,(a0)+
		dbf	d2,loc_250
		move.w	d0,(a2)
		move.w	d0,(a1)
		move.w	d7,(a2)

loc_25C:				
		move.l	d0,-(a6)
		dbf	d6,loc_25C
		move.l	(a5)+,(a4)
		move.l	(a5)+,(a4)
		moveq	#$1F,d3

loc_268:				
		move.l	d0,(a3)
		dbf	d3,loc_268
		move.l	(a5)+,(a4)
		moveq	#$13,d4

loc_272:				
		move.l	d0,(a3)
		dbf	d4,loc_272
		moveq	#3,d5

loc_27A:				
		move.b	(a5)+,$11(a3)
		dbf	d5,loc_27A
		move.w	d0,(a2)
		movem.l	(a6),d0-a6
		move	#$2700,sr

loc_28C:				
		bra.s	loc_2FA
; ---------------------------------------------------------------------------
std_init_table:	dc.w $8000		
		dc.w $3FFF
		dc.w $100
		dc.l Z80_Ram
		dc.l IO_Z80Bus
		dc.l IO_Z80Res
		dc.l VDP_Data
		dc.l VDP_Control
		dc.b 4,	$14, $38, $18, 6, $78, 0, 0, 0,	0, $FF,	0, $81
		dc.b $3D, 0, 1,	1, 0, 0, $FF, $FF, 0, 0, $80, $40, 0, 0
		dc.b $80, $AF, 1, $D9, $1F, $11, $27, 0, $21, $26, 0, $F9
		dc.b $77, $ED, $B0, $DD, $E1, $FD, $E1,	$ED, $47, $ED
		dc.b $4F, $D1, $E1, $F1, 8, $D9, $C1, $D1, $E1,	$F1, $F9
		dc.b $F3, $ED, $56, $36, $E9, $E9, $81,	4, $8F,	2, $C0
		dc.b 0,	0, 0, $40, 0, 0, $10
		dc.b $9F, $BF, $DF, $FF
; ---------------------------------------------------------------------------

loc_2FA:				
		tst.w	(VDP_Control).l
wait_dma_end:
		moveq	#2,d0
		and.w	(VDP_Control).l,d0
		bne.s	wait_dma_end
; ---------------------------------------------------------------------------
; End of function RESET

Z80_RAM      equ  $A00000
IO_Z80BUS    equ  $A11100
IO_Z80RES    equ  $A11200

VDP_DATA     equ  $C00000
VDP_CONTROL  equ  $C00004
VDP_COUNTER  equ  $C00008
